Index: trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/VBoxOGL.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/VBoxOGL.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/VBoxOGL.cpp	(revision 10552)
@@ -257,5 +257,5 @@
 
     if (DeviceIoControl (vboxOGLCtx.hGuestDrv,
-                         VBOXGUEST_IOCTL_HGCM_CALL,
+                         VBOXGUEST_IOCTL_HGCM_CALL(cbData),
                          pvData, cbData,
                          pvData, cbData,
Index: trunk/src/VBox/Additions/WINNT/VBoxControl/VBoxControl.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxControl/VBoxControl.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxControl/VBoxControl.cpp	(revision 10552)
@@ -883,5 +883,5 @@
 
     if (DeviceIoControl (hDevice,
-                         VBOXGUEST_IOCTL_HGCM_CALL,
+                         VBOXGUEST_IOCTL_HGCM_CALL(cbMsg),
                          pMsg, cbMsg,
                          pMsg, cbMsg,
Index: trunk/src/VBox/Additions/WINNT/VBoxGINA/Helper.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxGINA/Helper.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxGINA/Helper.cpp	(revision 10552)
@@ -68,5 +68,5 @@
     vmmreqCredentials.u32Flags |= VMMDEV_CREDENTIALS_QUERYPRESENCE;
     DWORD cbReturned;
-    if (!DeviceIoControl(vboxDriver, VBOXGUEST_IOCTL_VMMREQUEST, &vmmreqCredentials, sizeof(vmmreqCredentials),
+    if (!DeviceIoControl(vboxDriver, VBOXGUEST_IOCTL_VMMREQUEST(sizeof(vmmreqCredentials)), &vmmreqCredentials, sizeof(vmmreqCredentials),
                          &vmmreqCredentials, sizeof(vmmreqCredentials), &cbReturned, NULL))
     {
@@ -96,5 +96,5 @@
     vmmreqCredentials.u32Flags |= VMMDEV_CREDENTIALS_CLEAR;
     DWORD cbReturned;
-    if (!DeviceIoControl(vboxDriver, VBOXGUEST_IOCTL_VMMREQUEST, &vmmreqCredentials, sizeof(vmmreqCredentials),
+    if (!DeviceIoControl(vboxDriver, VBOXGUEST_IOCTL_VMMREQUEST(sizeof(vmmreqCredentials)), &vmmreqCredentials, sizeof(vmmreqCredentials),
                          &vmmreqCredentials, sizeof(vmmreqCredentials), &cbReturned, NULL))
     {
Index: trunk/src/VBox/Additions/WINNT/VBoxGuest/VBoxGuest.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxGuest/VBoxGuest.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxGuest/VBoxGuest.cpp	(revision 10552)
@@ -797,5 +797,5 @@
         }
 
-        case VBOXGUEST_IOCTL_VMMREQUEST:
+        case VBOXGUEST_IOCTL_VMMREQUEST(sizeof(VMMDevRequestHeader)):
         {
             dprintf(("VBoxGuest::VBoxGuestDeviceControl: VBOXGUEST_IOCTL_VMMREQUEST\n"));
@@ -972,5 +972,5 @@
         } break;
 
-        case VBOXGUEST_IOCTL_HGCM_CALL:
+        case VBOXGUEST_IOCTL_HGCM_CALL(sizeof(VBoxGuestHGCMCallInfo)):
         {
             dprintf(("VBoxGuest::VBoxGuestDeviceControl: VBOXGUEST_IOCTL_HGCM_CALL\n"));
Index: trunk/src/VBox/Additions/WINNT/VBoxHook/VBoxHook.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxHook/VBoxHook.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxHook/VBoxHook.cpp	(revision 10552)
@@ -135,5 +135,5 @@
 {
     DWORD cbReturned;
-    DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST, pReq, pReq->size,
+    DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST(pReq->size), pReq, pReq->size,
                     pReq, pReq->size, &cbReturned, NULL);
     return VINF_SUCCESS;
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxClipboard.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxClipboard.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxClipboard.cpp	(revision 10552)
@@ -162,5 +162,5 @@
 
     if (DeviceIoControl (hDriver,
-                         VBOXGUEST_IOCTL_HGCM_CALL,
+                         VBOXGUEST_IOCTL_HGCM_CALL(cbData),
                          pvData, cbData,
                          pvData, cbData,
@@ -815,5 +815,5 @@
 
         if (!DeviceIoControl (hDriver,
-                              VBOXGUEST_IOCTL_HGCM_CALL,
+                              VBOXGUEST_IOCTL_HGCM_CALL(sizeof (parms)),
                               &parms, sizeof (parms),
                               &parms, sizeof (parms),
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp	(revision 10552)
@@ -409,5 +409,5 @@
                     displayChangeRequest.header.requestType = VMMDevReq_GetDisplayChangeRequest2;
                     displayChangeRequest.eventAck           = VMMDEV_EVENT_DISPLAY_CHANGE_REQUEST;
-                    BOOL fDisplayChangeQueried = DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST, &displayChangeRequest, sizeof(VMMDevDisplayChangeRequest2),
+                    BOOL fDisplayChangeQueried = DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST(sizeof(VMMDevDisplayChangeRequest2)), &displayChangeRequest, sizeof(VMMDevDisplayChangeRequest2),
                                                                  &displayChangeRequest, sizeof(VMMDevDisplayChangeRequest2), &cbReturned, NULL);
                     if (!fDisplayChangeQueried)
@@ -418,5 +418,5 @@
                         displayChangeRequest.header.requestType = VMMDevReq_GetDisplayChangeRequest;
                         displayChangeRequest.eventAck           = VMMDEV_EVENT_DISPLAY_CHANGE_REQUEST;
-                        fDisplayChangeQueried = DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST, &displayChangeRequest, sizeof(VMMDevDisplayChangeRequest),
+                        fDisplayChangeQueried = DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST(sizeof(VMMDevDisplayChangeRequest)), &displayChangeRequest, sizeof(VMMDevDisplayChangeRequest),
                                                                  &displayChangeRequest, sizeof(VMMDevDisplayChangeRequest), &cbReturned, NULL);
                         displayChangeRequest.display = 0;
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxSeamless.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxSeamless.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxSeamless.cpp	(revision 10552)
@@ -85,5 +85,5 @@
 
         DWORD cbReturned;
-        if (!DeviceIoControl(pEnv->hDriver, VBOXGUEST_IOCTL_VMMREQUEST, &vmmreqGuestCaps, sizeof(vmmreqGuestCaps),
+        if (!DeviceIoControl(pEnv->hDriver, VBOXGUEST_IOCTL_VMMREQUEST(sizeof(vmmreqGuestCaps)), &vmmreqGuestCaps, sizeof(vmmreqGuestCaps),
                              &vmmreqGuestCaps, sizeof(vmmreqGuestCaps), &cbReturned, NULL))
         {
@@ -115,5 +115,5 @@
 
     DWORD cbReturned;
-    if (!DeviceIoControl(pEnv->hDriver, VBOXGUEST_IOCTL_VMMREQUEST, &vmmreqGuestCaps, sizeof(vmmreqGuestCaps),
+    if (!DeviceIoControl(pEnv->hDriver, VBOXGUEST_IOCTL_VMMREQUEST(sizeof(vmmreqGuestCaps)), &vmmreqGuestCaps, sizeof(vmmreqGuestCaps),
                          &vmmreqGuestCaps, sizeof(vmmreqGuestCaps), &cbReturned, NULL))
     {
@@ -337,5 +337,5 @@
                     seamlessChangeRequest.eventAck = VMMDEV_EVENT_SEAMLESS_MODE_CHANGE_REQUEST;
 
-                    BOOL fSeamlessChangeQueried = DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST, &seamlessChangeRequest, sizeof(seamlessChangeRequest),
+                    BOOL fSeamlessChangeQueried = DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST(sizeof(seamlessChangeRequest)), &seamlessChangeRequest, sizeof(seamlessChangeRequest),
                                                                  &seamlessChangeRequest, sizeof(seamlessChangeRequest), &cbReturned, NULL);
                     if (fSeamlessChangeQueried)
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxStatistics.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxStatistics.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxStatistics.cpp	(revision 10552)
@@ -69,5 +69,5 @@
     req.eventAck = 0;
 
-    if (DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST, &req, req.header.size, &req, req.header.size, &cbReturned, NULL))
+    if (DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST(req.header.size), &req, req.header.size, &req, req.header.size, &cbReturned, NULL))
     {
         dprintf(("VBoxStatsInit: new statistics interval %d seconds\n", req.u32StatInterval));
@@ -225,5 +225,5 @@
         req.guestStats.u32CpuId = i;
 
-        if (DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST, &req, req.header.size, &req, req.header.size, &cbReturned, NULL))
+        if (DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST(req.header.size), &req, req.header.size, &req, req.header.size, &cbReturned, NULL))
         {
             dprintf(("VBoxStatsReportStatistics: new statistics reported successfully!\n"));
@@ -283,5 +283,5 @@
                 req.eventAck = VMMDEV_EVENT_STATISTICS_INTERVAL_CHANGE_REQUEST;
 
-                if (DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST, &req, req.header.size, &req, req.header.size, &cbReturned, NULL))
+                if (DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST(req.header.size), &req, req.header.size, &req, req.header.size, &cbReturned, NULL))
                 {
                     dprintf(("VBoxStatsThread: new statistics interval %d seconds\n", req.u32StatInterval));
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxTray.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxTray.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxTray.cpp	(revision 10552)
@@ -84,5 +84,5 @@
     }
 
-    DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST, pReq, pReq->header.size,
+    DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_VMMREQUEST(pReq->header.size), pReq, pReq->header.size,
                     pReq, pReq->header.size, &cbReturned, NULL);
 
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxVRDP.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxVRDP.cpp	(revision 10541)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxVRDP.cpp	(revision 10552)
@@ -360,5 +360,5 @@
                 
                 if (DeviceIoControl (gVBoxDriver,
-                                     VBOXGUEST_IOCTL_VMMREQUEST,
+                                     VBOXGUEST_IOCTL_VMMREQUEST(sizeof(VMMDevVRDPChangeRequest)),
                                      &vrdpChangeRequest,
                                      sizeof(VMMDevVRDPChangeRequest),