Index: /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxGLSettingsUpdate.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxGLSettingsUpdate.h	(revision 10610)
+++ /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxGLSettingsUpdate.h	(revision 10611)
@@ -50,5 +50,4 @@
 
     void toggleUpdater (bool aOn);
-    void toggleType();
     void activatedPeriod (int aIndex);
 
@@ -57,5 +56,4 @@
     void showEvent (QShowEvent *aEvent);
 
-    QRadioButton *mLastSelected;
     bool mSettingsChanged;
 };
Index: /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxUpdateDlg.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxUpdateDlg.h	(revision 10610)
+++ /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxUpdateDlg.h	(revision 10611)
@@ -61,6 +61,5 @@
     enum
     {
-        NeverCheck = -2,
-        AutoCheck  = -3
+        NeverCheck = -2
     };
 
@@ -72,5 +71,5 @@
 
     bool isNecessary();
-    bool isAutomatic();
+    bool isNeverCheck();
 
     QString data() const;
@@ -100,5 +99,4 @@
 
     static bool isNecessary();
-    static bool isAutomatic();
 
     VBoxUpdateDlg (VBoxUpdateDlg **aSelf, bool aForceRun,
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGLSettingsUpdate.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGLSettingsUpdate.cpp	(revision 10610)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGLSettingsUpdate.cpp	(revision 10611)
@@ -26,6 +26,5 @@
 
 VBoxGLSettingsUpdate::VBoxGLSettingsUpdate()
-    : mLastSelected (0)
-    , mSettingsChanged (false)
+    : mSettingsChanged (false)
 {
     /* Apply UI decorations */
@@ -33,8 +32,6 @@
 
     /* Setup connections */
-    connect (mGbCheck, SIGNAL (toggled (bool)),
+    connect (mCbCheck, SIGNAL (toggled (bool)),
              this, SLOT (toggleUpdater (bool)));
-    connect (mRbAuto, SIGNAL (clicked()), this, SLOT (toggleType()));
-    connect (mRbOncePer, SIGNAL (clicked()), this, SLOT (toggleType()));
     connect (mCbOncePer, SIGNAL (activated (int)),
              this, SLOT (activatedPeriod (int)));
@@ -50,23 +47,7 @@
                          GetExtraData (VBoxDefs::GUI_UpdateDate));
 
-    if (data.index() == VBoxUpdateData::NeverCheck)
-    {
-        mGbCheck->setChecked (false);
-    }
-    else
-    {
-        mGbCheck->setChecked (true);
-
-        if (data.isAutomatic())
-        {
-            mRbAuto->setChecked (true);
-        }
-        else
-        {
-            mRbOncePer->setChecked (true);
-            Assert (data.index() >= 0);
-            mCbOncePer->setCurrentIndex (data.index());
-        }
-    }
+    mCbCheck->setChecked (!data.isNeverCheck());
+    if (mCbCheck->isChecked())
+        mCbOncePer->setCurrentIndex (data.index());
     mTxDate->setText (data.date());
 
@@ -80,21 +61,9 @@
         return;
 
-    int index = -1;
-
-    if (!mGbCheck->isChecked())
-    {
-        index = VBoxUpdateData::NeverCheck;
-    }
-    else
-    {
-        if (mRbAuto->isChecked())
-            index = VBoxUpdateData::AutoCheck;
-        else
-            index = mCbOncePer->currentIndex();
-    }
+    int index = mCbCheck->isChecked() ? mCbOncePer->currentIndex() :
+                                        VBoxUpdateData::NeverCheck;
     Assert (index != -1);
 
     VBoxUpdateData newData (index);
-
     vboxGlobal().virtualBox().SetExtraData (VBoxDefs::GUI_UpdateDate,
                                             newData.data());
@@ -103,8 +72,6 @@
 void VBoxGLSettingsUpdate::setOrderAfter (QWidget *aWidget)
 {
-    setTabOrder (aWidget, mGbCheck);
-    setTabOrder (mGbCheck, mRbAuto);
-    setTabOrder (mRbAuto, mRbOncePer);
-    setTabOrder (mRbOncePer, mCbOncePer);
+    setTabOrder (aWidget, mCbCheck);
+    setTabOrder (mCbCheck, mCbOncePer);
 }
 
@@ -124,40 +91,13 @@
 void VBoxGLSettingsUpdate::toggleUpdater (bool aOn)
 {
-    /* Toggle auto-exclusiveness on/off to let the buttons be
-     * unchecked both in case of group-box is not checked and
-     * exclusively checked in case of group-box is checked. */
-    mRbAuto->setAutoExclusive (aOn);
-    mRbOncePer->setAutoExclusive (aOn);
+    /* Enable/disable the sub widget */
+    mLbOncePer->setEnabled (aOn);
+    mCbOncePer->setEnabled (aOn);
 
-    /* Enable/disable the sub widget */
-    mGbCheckContent->setEnabled (aOn);
-
-    /* Toggle both buttons off when the group box unchecked. */
-    if (!aOn)
-    {
-        mLastSelected = mRbOncePer->isChecked() ? mRbOncePer : mRbAuto;
-        mRbAuto->blockSignals (true);
-        mRbOncePer->blockSignals (true);
-        mRbAuto->setChecked (false);
-        mRbOncePer->setChecked (false);
-        mRbAuto->blockSignals (false);
-        mRbOncePer->blockSignals (false);
+    /* Update 'check for new version' time */
+    if (aOn)
+        activatedPeriod (mCbOncePer->currentIndex());
+    else
         activatedPeriod (VBoxUpdateData::NeverCheck);
-    }
-    /* Toggle last checked button on when the group box checked. */
-    else if (!mRbAuto->isChecked() && !mRbOncePer->isChecked())
-    {
-        mLastSelected->blockSignals (true);
-        mLastSelected->setChecked (true);
-        mLastSelected->blockSignals (false);
-        toggleType();
-    }
-}
-
-void VBoxGLSettingsUpdate::toggleType()
-{
-    mCbOncePer->setEnabled (mRbOncePer->isChecked());
-    activatedPeriod (mRbAuto->isChecked() ?
-        VBoxUpdateData::AutoCheck : mCbOncePer->currentIndex());
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxUpdateDlg.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxUpdateDlg.cpp	(revision 10610)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxUpdateDlg.cpp	(revision 10611)
@@ -125,7 +125,7 @@
 }
 
-bool VBoxUpdateData::isAutomatic()
-{
-    return mIndex == AutoCheck;
+bool VBoxUpdateData::isNeverCheck()
+{
+    return mIndex == NeverCheck;
 }
 
@@ -143,5 +143,4 @@
 {
     return mIndex == NeverCheck ? VBoxUpdateDlg::tr ("never") :
-           mIndex == AutoCheck ? VBoxUpdateDlg::tr ("on startup") :
            mDate.toString ("yyyy.MM.dd");
 }
@@ -150,7 +149,5 @@
 {
     /* Parse standard values */
-    if (aData == "auto")
-        mIndex = AutoCheck;
-    else if (aData == "never")
+    if (aData == "never")
         mIndex = NeverCheck;
     /* Parse other values */
@@ -182,7 +179,5 @@
 {
     /* Encode standard values */
-    if (aIndex == AutoCheck)
-        mData = "auto";
-    else if (aIndex == NeverCheck)
+    if (aIndex == NeverCheck)
         mData = "never";
     /* Encode other values */
@@ -218,12 +213,4 @@
 
     return data.isNecessary();
-}
-
-bool VBoxUpdateDlg::isAutomatic()
-{
-    VBoxUpdateData data (vboxGlobal().virtualBox().
-        GetExtraData (VBoxDefs::GUI_UpdateDate));
-
-    return data.isAutomatic();
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxGLSettingsUpdate.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxGLSettingsUpdate.ui	(revision 10610)
+++ /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxGLSettingsUpdate.ui	(revision 10611)
@@ -40,6 +40,6 @@
     <number>0</number>
    </property>
-   <item row="0" column="1" colspan="2" >
-    <widget class="QCheckBox" name="mGbCheck" >
+   <item row="0" column="1" >
+    <widget class="QCheckBox" name="mCbCheck" >
      <property name="text" >
       <string>&amp;Check for a new version</string>
@@ -61,5 +61,5 @@
       <size>
        <width>40</width>
-       <height>20</height>
+       <height>10</height>
       </size>
      </property>
@@ -67,94 +67,69 @@
    </item>
    <item row="1" column="1" >
-    <spacer>
-     <property name="orientation" >
-      <enum>Qt::Horizontal</enum>
+    <layout class="QHBoxLayout" >
+     <property name="spacing" >
+      <number>0</number>
      </property>
-     <property name="sizeType" >
-      <enum>QSizePolicy::Fixed</enum>
-     </property>
-     <property name="sizeHint" >
-      <size>
-       <width>20</width>
-       <height>40</height>
-      </size>
-     </property>
-    </spacer>
+     <item>
+      <spacer>
+       <property name="orientation" >
+        <enum>Qt::Horizontal</enum>
+       </property>
+       <property name="sizeType" >
+        <enum>QSizePolicy::Fixed</enum>
+       </property>
+       <property name="sizeHint" >
+        <size>
+         <width>20</width>
+         <height>10</height>
+        </size>
+       </property>
+      </spacer>
+     </item>
+     <item>
+      <widget class="QLabel" name="mLbOncePer" >
+       <property name="text" >
+        <string>&amp;Once per</string>
+       </property>
+       <property name="buddy" >
+        <cstring>mCbOncePer</cstring>
+       </property>
+      </widget>
+     </item>
+     <item>
+      <spacer>
+       <property name="orientation" >
+        <enum>Qt::Horizontal</enum>
+       </property>
+       <property name="sizeType" >
+        <enum>QSizePolicy::Fixed</enum>
+       </property>
+       <property name="sizeHint" >
+        <size>
+         <width>16</width>
+         <height>10</height>
+        </size>
+       </property>
+      </spacer>
+     </item>
+     <item>
+      <widget class="QComboBox" name="mCbOncePer" />
+     </item>
+     <item>
+      <spacer>
+       <property name="orientation" >
+        <enum>Qt::Horizontal</enum>
+       </property>
+       <property name="sizeHint" >
+        <size>
+         <width>0</width>
+         <height>10</height>
+        </size>
+       </property>
+      </spacer>
+     </item>
+    </layout>
    </item>
-   <item row="1" column="2" >
-    <widget class="QWidget" native="1" name="mGbCheckContent" >
-     <layout class="QGridLayout" >
-      <property name="leftMargin" >
-       <number>0</number>
-      </property>
-      <property name="topMargin" >
-       <number>0</number>
-      </property>
-      <property name="rightMargin" >
-       <number>0</number>
-      </property>
-      <property name="bottomMargin" >
-       <number>0</number>
-      </property>
-      <property name="verticalSpacing" >
-       <number>0</number>
-      </property>
-      <item row="0" column="0" >
-       <widget class="QRadioButton" name="mRbAuto" >
-        <property name="text" >
-         <string>On &amp;startup</string>
-        </property>
-       </widget>
-      </item>
-      <item row="1" column="0" >
-       <widget class="QRadioButton" name="mRbOncePer" >
-        <property name="text" >
-         <string>&amp;Once per</string>
-        </property>
-       </widget>
-      </item>
-      <item row="1" column="1" >
-       <layout class="QHBoxLayout" >
-        <property name="spacing" >
-         <number>0</number>
-        </property>
-        <item>
-         <spacer>
-          <property name="orientation" >
-           <enum>Qt::Horizontal</enum>
-          </property>
-          <property name="sizeType" >
-           <enum>QSizePolicy::Fixed</enum>
-          </property>
-          <property name="sizeHint" >
-           <size>
-            <width>16</width>
-            <height>16</height>
-           </size>
-          </property>
-         </spacer>
-        </item>
-        <item>
-         <widget class="QComboBox" name="mCbOncePer" />
-        </item>
-        <item>
-         <spacer>
-          <property name="orientation" >
-           <enum>Qt::Horizontal</enum>
-          </property>
-          <property name="sizeHint" >
-           <size>
-            <width>0</width>
-            <height>16</height>
-           </size>
-          </property>
-         </spacer>
-        </item>
-       </layout>
-      </item>
-     </layout>
-    </widget>
-   </item>
-   <item row="2" column="1" colspan="2" >
+   <item row="2" column="1" >
     <layout class="QHBoxLayout" >
      <property name="spacing" >
@@ -186,5 +161,5 @@
     </layout>
    </item>
-   <item row="3" column="2" >
+   <item row="3" column="1" >
     <spacer>
      <property name="orientation" >
@@ -193,6 +168,6 @@
      <property name="sizeHint" >
       <size>
-       <width>20</width>
-       <height>40</height>
+       <width>10</width>
+       <height>0</height>
       </size>
      </property>