Index: trunk/src/VBox/HostDrivers/Support/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/Support/Makefile.kmk	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/Makefile.kmk	(revision 10662)
@@ -150,5 +150,5 @@
  VBoxDrv_NOINST       = true
 endif
-VBoxDrv_DEFS          = IN_RT_R0 IN_SUP_R0
+VBoxDrv_DEFS          = IN_RT_R0 IN_SUP_R0 SUPDRV_WITH_RELEASE_LOGGER
 ifdef VBOX_WITH_IDT_PATCHING
 VBoxDrv_DEFS         += VBOX_WITH_IDT_PATCHING
@@ -229,5 +229,5 @@
 ifeq ($(KBUILD_TARGET),darwin)
 VBoxDrv_TEMPLATE      = VBOXR0DRV
-VBoxDrv_DEFS          = IN_RT_R0 IN_SUP_R0
+VBoxDrv_DEFS          = IN_RT_R0 IN_SUP_R0 SUPDRV_WITH_RELEASE_LOGGER VBOX_SVN_REV=$(VBOX_SVN_REV)
 ifdef VBOX_WITH_IDT_PATCHING
 VBoxDrv_DEFS         += VBOX_WITH_IDT_PATCHING
@@ -304,5 +304,5 @@
 ifeq ($(KBUILD_TARGET),freebsd)
 vboxdrv_TEMPLATE      = VBOXR0DRV
-vboxdrv_DEFS          = IN_RT_R0 IN_SUP_R0
+vboxdrv_DEFS          = IN_RT_R0 IN_SUP_R0 SUPDRV_WITH_RELEASE_LOGGER VBOX_SVN_REV=$(VBOX_SVN_REV)
 ifdef VBOX_WITH_IDT_PATCHING
 vboxdrv_DEFS         += VBOX_WITH_IDT_PATCHING
Index: trunk/src/VBox/HostDrivers/Support/SUPDrv.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPDrv.c	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/SUPDrv.c	(revision 10662)
@@ -1,5 +1,5 @@
 /* $Revision$ */
 /** @file
- * VirtualBox Support Driver - Shared code.
+ * VBoxDrv - The VirtualBox Support Driver - Common code.
  */
 
@@ -29,8 +29,8 @@
  */
 
-
 /*******************************************************************************
 *   Header Files                                                               *
 *******************************************************************************/
+#define LOG_GROUP LOG_GROUP_SUP_DRV
 #include "SUPDrvInternal.h"
 #ifndef PAGE_SHIFT
@@ -44,6 +44,6 @@
 #include <iprt/mp.h>
 #include <iprt/cpuset.h>
-#include <iprt/log.h>
 #include <iprt/uuid.h>
+#include <VBox/log.h>
 #include <VBox/err.h>
 /* VBox/x86.h not compatible with the Linux kernel sources */
@@ -125,4 +125,7 @@
 {
     /* name                                     function */
+    { "SUPR0ComponentRegisterFactory",          (void *)SUPR0ComponentRegisterFactory },
+    { "SUPR0ComponentDeregisterFactory",        (void *)SUPR0ComponentDeregisterFactory },
+    { "SUPR0ComponentQueryFactory",             (void *)SUPR0ComponentQueryFactory },
     { "SUPR0ObjRegister",                       (void *)SUPR0ObjRegister },
     { "SUPR0ObjAddRef",                         (void *)SUPR0ObjAddRef },
@@ -274,8 +277,22 @@
 int VBOXCALL supdrvInitDevExt(PSUPDRVDEVEXT pDevExt)
 {
+    int rc;
+
+#ifdef SUPDRV_WITH_RELEASE_LOGGER
+    /*
+     * Create the release log.
+     */
+    static const char * const s_apszGroups[] = VBOX_LOGGROUP_NAMES;
+    PRTLOGGER pRelLogger;
+    rc = RTLogCreate(&pRelLogger, 0 /* fFlags */, "all",
+                     "VBOX_RELEASE_LOG", RT_ELEMENTS(s_apszGroups), s_apszGroups,
+                     RTLOGDEST_STDOUT | RTLOGDEST_DEBUGGER, NULL);
+    if (RT_SUCCESS(rc))
+        RTLogRelSetDefaultInstance(pRelLogger);
+#endif
+
     /*
      * Initialize it.
      */
-    int rc;
     memset(pDevExt, 0, sizeof(*pDevExt));
     rc = RTSpinlockCreate(&pDevExt->Spinlock);
@@ -310,4 +327,9 @@
         pDevExt->Spinlock = NIL_RTSPINLOCK;
     }
+#ifdef SUPDRV_WITH_RELEASE_LOGGER
+    RTLogDestroy(RTLogRelSetDefaultInstance(NULL));
+    RTLogDestroy(RTLogSetDefaultInstance(NULL));
+#endif
+
     return rc;
 }
@@ -376,6 +398,12 @@
     }
 
-    /* kill the GIP */
+    /* kill the GIP. */
     supdrvGipDestroy(pDevExt);
+
+#ifdef SUPDRV_WITH_RELEASE_LOGGER
+    /* destroy the loggers. */
+    RTLogDestroy(RTLogRelSetDefaultInstance(NULL));
+    RTLogDestroy(RTLogSetDefaultInstance(NULL));
+#endif
 }
 
@@ -4881,5 +4909,6 @@
 
 
-#ifndef DEBUG /** @todo change #ifndef DEBUG -> #ifdef LOG_ENABLED */
+#ifndef SUPDRV_WITH_RELEASE_LOGGER
+# ifndef DEBUG /** @todo change #ifndef DEBUG -> #ifdef LOG_ENABLED */
 /**
  * Stub function for non-debug builds.
@@ -4937,4 +4966,4 @@
 {
 }
-#endif /* !DEBUG */
-
+# endif /* !DEBUG */
+#endif /* !SUPDRV_WITH_RELEASE_LOGGER */
Index: trunk/src/VBox/HostDrivers/Support/SUPDrvIOC.h
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPDrvIOC.h	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/SUPDrvIOC.h	(revision 10662)
@@ -182,5 +182,5 @@
  * The upper 16-bit is the major version, the the lower the minor version.
  * When incompatible changes are made, the upper major number has to be changed. */
-#define SUPDRVIOC_VERSION                               0x00070003
+#define SUPDRVIOC_VERSION                               0x00070004
 
 /** SUP_IOCTL_COOKIE. */
Index: trunk/src/VBox/HostDrivers/Support/SUPLib.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPLib.cpp	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/SUPLib.cpp	(revision 10662)
@@ -213,5 +213,5 @@
         CookieReq.u.In.u32ReqVersion = SUPDRVIOC_VERSION;
         const uint32_t MinVersion = (SUPDRVIOC_VERSION & 0xffff0000) == 0x00070000
-                                  ? 0x00070002 /* need new exports */
+                                  ? 0x00070004 /* need new exports */
                                   : SUPDRVIOC_VERSION & 0xffff0000;
         CookieReq.u.In.u32MinVersion = MinVersion;
@@ -326,4 +326,7 @@
     {
         /* name                                     function */
+        { "SUPR0ComponentRegisterFactory",          0xefeefffd },
+        { "SUPR0ComponentDeregisterFactory",        0xefeefffe },
+        { "SUPR0ComponentQueryFactory",             0xefeeffff },
         { "SUPR0ObjRegister",                       0xefef0000 },
         { "SUPR0ObjAddRef",                         0xefef0001 },
Index: trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp	(revision 10662)
@@ -1,3 +1,5 @@
+/* $Id: $ */
 /** @file
+ *
  * VBox host drivers - Ring-0 support drivers - Darwin host:
  * Darwin driver C code
@@ -29,8 +31,8 @@
  */
 
-
 /*******************************************************************************
 *   Header Files                                                               *
 *******************************************************************************/
+#define LOG_GROUP LOG_GROUP_SUP_DRV
 /*
  * Deal with conflicts first.
@@ -54,4 +56,5 @@
 #include <iprt/uuid.h>
 #include <iprt/err.h>
+#include <VBox/log.h>
 
 #include <mach/kmod.h>
@@ -219,5 +222,7 @@
 {
     int rc;
-    dprintf(("VBoxDrvDarwinStart\n"));
+#ifdef DEBUG
+    printf("VBoxDrvDarwinStart\n");
+#endif
 
     /*
@@ -251,28 +256,28 @@
                     if (g_hDevFsDevice)
                     {
-                        OSDBGPRINT(("VBoxDrv: Successfully started. (major=%d)\n", g_iMajorDeviceNo));
+                        LogRel(("VBoxDrv: version " VBOX_VERSION_STRING " r%d; IOCtl version %#x; IDC version %#x; dev major=%d\n",
+                                VBOX_SVN_REV, SUPDRVIOC_VERSION, SUPDRV_IDC_VERSION, g_iMajorDeviceNo));
                         return KMOD_RETURN_SUCCESS;
                     }
 
-                    OSDBGPRINT(("VBoxDrv: devfs_make_node(makedev(%d,0),,,,%s) failed\n",
-                                g_iMajorDeviceNo, DEVICE_NAME));
+                    LogRel(("VBoxDrv: devfs_make_node(makedev(%d,0),,,,%s) failed\n", g_iMajorDeviceNo, DEVICE_NAME));
                     cdevsw_remove(g_iMajorDeviceNo, &g_DevCW);
                     g_iMajorDeviceNo = -1;
                 }
                 else
-                    OSDBGPRINT(("VBoxDrv: cdevsw_add failed (%d)\n", g_iMajorDeviceNo));
+                    LogRel(("VBoxDrv: cdevsw_add failed (%d)\n", g_iMajorDeviceNo));
                 RTSpinlockDestroy(g_Spinlock);
                 g_Spinlock = NIL_RTSPINLOCK;
             }
             else
-                OSDBGPRINT(("VBoxDrv: RTSpinlockCreate failed (rc=%d)\n", rc));
+                LogRel(("VBoxDrv: RTSpinlockCreate failed (rc=%d)\n", rc));
             supdrvDeleteDevExt(&g_DevExt);
         }
         else
-            OSDBGPRINT(("VBoxDrv: failed to initialize device extension (rc=%d)\n", rc));
+            printf("VBoxDrv: failed to initialize device extension (rc=%d)\n", rc);
         RTR0Term();
     }
     else
-        OSDBGPRINT(("VBoxDrv: failed to initialize IPRT (rc=%d)\n", rc));
+        printf("VBoxDrv: failed to initialize IPRT (rc=%d)\n", rc);
 
     memset(&g_DevExt, 0, sizeof(g_DevExt));
@@ -287,5 +292,5 @@
 {
     int rc;
-    dprintf(("VBoxDrvDarwinStop\n"));
+    LogFlow(("VBoxDrvDarwinStop\n"));
 
     /** @todo I've got a nagging feeling that we'll have to keep track of users and refuse
@@ -311,5 +316,7 @@
 
     memset(&g_DevExt, 0, sizeof(g_DevExt));
-    dprintf(("VBoxDrvDarwinStop - done\n"));
+#ifdef DEBUG
+    printf("VBoxDrvDarwinStop - done\n");
+#endif
     return KMOD_RETURN_SUCCESS;
 }
@@ -330,5 +337,5 @@
     szName[0] = '\0';
     proc_name(proc_pid(pProcess), szName, sizeof(szName));
-    dprintf(("VBoxDrvDarwinOpen: pid=%d '%s'\n", proc_pid(pProcess), szName));
+    Log(("VBoxDrvDarwinOpen: pid=%d '%s'\n", proc_pid(pProcess), szName));
 #endif
 
@@ -362,5 +369,5 @@
     OSDBGPRINT(("VBoxDrvDarwinOpen: pid=%d '%s' pSession=%p rc=%d\n", proc_pid(pProcess), szName, pSession, rc));
 #else
-    dprintf(("VBoxDrvDarwinOpen: g_DevExt=%p pSession=%p rc=%d pid=%d\n", &g_DevExt, pSession, rc, proc_pid(pProcess)));
+    Log(("VBoxDrvDarwinOpen: g_DevExt=%p pSession=%p rc=%d pid=%d\n", &g_DevExt, pSession, rc, proc_pid(pProcess)));
 #endif
     return VBoxDrvDarwinErr2DarwinErr(rc);
@@ -378,5 +385,5 @@
     PSUPDRVSESSION  pSession;
 
-    dprintf(("VBoxDrvDarwinClose: pid=%d\n", (int)Process));
+    Log(("VBoxDrvDarwinClose: pid=%d\n", (int)Process));
 
     /*
@@ -488,5 +495,5 @@
 static int VBoxDrvDarwinIOCtlSlow(PSUPDRVSESSION pSession, u_long iCmd, caddr_t pData, struct proc *pProcess)
 {
-    dprintf(("VBoxDrvDarwinIOCtlSlow: pSession=%p iCmd=%p pData=%p pProcess=%p\n", pSession, iCmd, pData, pProcess));
+    LogFlow(("VBoxDrvDarwinIOCtlSlow: pSession=%p iCmd=%p pData=%p pProcess=%p\n", pSession, iCmd, pData, pProcess));
 
 
@@ -571,5 +578,5 @@
     else
     {
-        dprintf(("VBoxDrvDarwinIOCtlSlow: huh? cbReq=%#x iCmd=%#lx\n", cbReq, iCmd));
+        Log(("VBoxDrvDarwinIOCtlSlow: huh? cbReq=%#x iCmd=%#lx\n", cbReq, iCmd));
         return EINVAL;
     }
@@ -617,9 +624,9 @@
         }
 
-        dprintf(("VBoxDrvDarwinIOCtlSlow: pid=%d iCmd=%lx pData=%p failed, rc=%d\n", proc_pid(pProcess), iCmd, (void *)pData, rc));
+        Log(("VBoxDrvDarwinIOCtlSlow: pid=%d iCmd=%lx pData=%p failed, rc=%d\n", proc_pid(pProcess), iCmd, (void *)pData, rc));
         rc = EINVAL;
     }
 
-    dprintf2(("VBoxDrvDarwinIOCtlSlow: returns %d\n", rc));
+    Log2(("VBoxDrvDarwinIOCtlSlow: returns %d\n", rc));
     return rc;
 }
@@ -778,5 +785,5 @@
 bool org_virtualbox_SupDrv::init(OSDictionary *pDictionary)
 {
-    dprintf(("org_virtualbox_SupDrv::init([%p], %p)\n", this, pDictionary));
+    LogFlow(("org_virtualbox_SupDrv::init([%p], %p)\n", this, pDictionary));
     if (IOService::init(pDictionary))
     {
@@ -793,5 +800,5 @@
 void org_virtualbox_SupDrv::free(void)
 {
-    dprintf(("IOService::free([%p])\n", this));
+    LogFlow(("IOService::free([%p])\n", this));
     IOService::free();
 }
@@ -804,5 +811,5 @@
 IOService *org_virtualbox_SupDrv::probe(IOService *pProvider, SInt32 *pi32Score)
 {
-    dprintf(("org_virtualbox_SupDrv::probe([%p])\n", this));
+    LogFlow(("org_virtualbox_SupDrv::probe([%p])\n", this));
     return IOService::probe(pProvider, pi32Score);
 }
@@ -814,5 +821,5 @@
 bool org_virtualbox_SupDrv::start(IOService *pProvider)
 {
-    dprintf(("org_virtualbox_SupDrv::start([%p])\n", this));
+    LogFlow(("org_virtualbox_SupDrv::start([%p])\n", this));
 
     if (IOService::start(pProvider))
@@ -831,5 +838,5 @@
 void org_virtualbox_SupDrv::stop(IOService *pProvider)
 {
-    dprintf(("org_virtualbox_SupDrv::stop([%p], %p)\n", this, pProvider));
+    LogFlow(("org_virtualbox_SupDrv::stop([%p], %p)\n", this, pProvider));
     IOService::stop(pProvider);
 }
@@ -845,5 +852,5 @@
 {
     bool fRc;
-    dprintf(("org_virtualbox_SupDrv::terminate: reference_count=%d g_cSessions=%d (fOptions=%#x)\n",
+    LogFlow(("org_virtualbox_SupDrv::terminate: reference_count=%d g_cSessions=%d (fOptions=%#x)\n",
              KMOD_INFO_NAME.reference_count, ASMAtomicUoReadS32(&g_cSessions), fOptions));
     if (    KMOD_INFO_NAME.reference_count != 0
@@ -852,5 +859,5 @@
     else
         fRc = IOService::terminate(fOptions);
-    dprintf(("org_virtualbox_SupDrv::terminate: returns %d\n", fRc));
+    LogFlow(("org_virtualbox_SupDrv::terminate: returns %d\n", fRc));
     return fRc;
 }
@@ -869,5 +876,5 @@
 bool org_virtualbox_SupDrvClient::initWithTask(task_t OwningTask, void *pvSecurityId, UInt32 u32Type)
 {
-    dprintf(("org_virtualbox_SupDrvClient::initWithTask([%p], %#x, %p, %#x)\n", this, OwningTask, pvSecurityId, u32Type));
+    LogFlow(("org_virtualbox_SupDrvClient::initWithTask([%p], %#x, %p, %#x)\n", this, OwningTask, pvSecurityId, u32Type));
 
     if (!OwningTask)
@@ -889,5 +896,5 @@
 bool org_virtualbox_SupDrvClient::start(IOService *pProvider)
 {
-    dprintf(("org_virtualbox_SupDrvClient::start([%p], %p)\n", this, pProvider));
+    LogFlow(("org_virtualbox_SupDrvClient::start([%p], %p)\n", this, pProvider));
     if (IOUserClient::start(pProvider))
     {
@@ -898,5 +905,5 @@
             return true;
         }
-        dprintf(("org_virtualbox_SupDrvClient::start: %p isn't org_virtualbox_SupDrv\n", pProvider));
+        LogFlow(("org_virtualbox_SupDrvClient::start: %p isn't org_virtualbox_SupDrv\n", pProvider));
     }
     return false;
@@ -909,5 +916,5 @@
 IOReturn org_virtualbox_SupDrvClient::clientClose(void)
 {
-    dprintf(("org_virtualbox_SupDrvClient::clientClose([%p])\n", this));
+    LogFlow(("org_virtualbox_SupDrvClient::clientClose([%p])\n", this));
 
     m_pProvider = NULL;
@@ -923,5 +930,5 @@
 IOReturn org_virtualbox_SupDrvClient::clientDied(void)
 {
-    dprintf(("org_virtualbox_SupDrvClient::clientDied([%p]) m_Task=%p R0Process=%p Process=%d\n",
+    LogFlow(("org_virtualbox_SupDrvClient::clientDied([%p]) m_Task=%p R0Process=%p Process=%d\n",
              this, m_Task, RTR0ProcHandleSelf(), RTProcSelf()));
 
@@ -937,5 +944,5 @@
         for (PSUPDRVSESSION pSession = g_apSessionHashTab[i]; pSession; pSession = pSession->pNextHash)
         {
-            dprintf2(("pSession=%p R0Process=%p (=? %p)\n", pSession, pSession->R0Process, R0Process));
+            Log2(("pSession=%p R0Process=%p (=? %p)\n", pSession, pSession->R0Process, R0Process));
             if (pSession->R0Process == R0Process)
             {
@@ -963,5 +970,5 @@
 bool org_virtualbox_SupDrvClient::terminate(IOOptionBits fOptions)
 {
-    dprintf(("org_virtualbox_SupDrvClient::terminate([%p], %#x)\n", this, fOptions));
+    LogFlow(("org_virtualbox_SupDrvClient::terminate([%p], %#x)\n", this, fOptions));
     return IOUserClient::terminate(fOptions);
 }
@@ -973,5 +980,5 @@
 bool org_virtualbox_SupDrvClient::finalize(IOOptionBits fOptions)
 {
-    dprintf(("org_virtualbox_SupDrvClient::finalize([%p], %#x)\n", this, fOptions));
+    LogFlow(("org_virtualbox_SupDrvClient::finalize([%p], %#x)\n", this, fOptions));
     return IOUserClient::finalize(fOptions);
 }
@@ -983,5 +990,5 @@
 void org_virtualbox_SupDrvClient::stop(IOService *pProvider)
 {
-    dprintf(("org_virtualbox_SupDrvClient::stop([%p])\n", this));
+    LogFlow(("org_virtualbox_SupDrvClient::stop([%p])\n", this));
     IOUserClient::stop(pProvider);
 }
Index: trunk/src/VBox/HostDrivers/Support/freebsd/SUPDrv-freebsd.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/freebsd/SUPDrv-freebsd.c	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/freebsd/SUPDrv-freebsd.c	(revision 10662)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * VBoxDrv - FreeBSD specifics.
+ * VBoxDrv - The VirtualBox Support Driver - FreeBSD specifics.
  */
 
@@ -29,8 +29,8 @@
  */
 
-
 /*******************************************************************************
 *   Header Files                                                               *
 *******************************************************************************/
+#define LOG_GROUP LOG_GROUP_SUP_DRV
 /* Deal with conflicts first. */
 #include <sys/param.h>
@@ -52,5 +52,5 @@
 #include <iprt/process.h>
 #include <iprt/assert.h>
-#include <iprt/log.h>
+#include <VBox/log.h>
 #include <iprt/alloc.h>
 #include <iprt/err.h>
Index: trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.c	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.c	(revision 10662)
@@ -1,5 +1,5 @@
 /* $Rev$ */
 /** @file
- * The VirtualBox Support Driver - Linux hosts.
+ * VBoxDrv - The VirtualBox Support Driver - Linux specifics.
  */
 
@@ -34,4 +34,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#define LOG_GROUP LOG_GROUP_SUP_DRV
 #include "../SUPDrvInternal.h"
 #include "the-linux-kernel.h"
@@ -45,5 +46,5 @@
 #include <iprt/err.h>
 #include <iprt/mem.h>
-#include <iprt/log.h>
+#include <VBox/log.h>
 #include <iprt/mp.h>
 
Index: trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.mod.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.mod.c	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.mod.c	(revision 10662)
@@ -1,6 +1,6 @@
+/* $Id$ */
 /** @file
- *
- * VBox host drivers - Ring-0 support drivers - Linux host:
- * Linux host kernel module interfaces
+ * VBoxDrv - The VirtualBox Support Driver - Autogenerated Linux code.
+ * This is checked in to assist syntax checking the module.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/os2/SUPDrv-os2.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/os2/SUPDrv-os2.cpp	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/os2/SUPDrv-os2.cpp	(revision 10662)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * VBoxDrv - OS/2 specifics.
+ * VBoxDrv - The VirtualBox Support Driver - OS/2 specifics.
  */
 
@@ -29,8 +29,8 @@
  */
 
-
 /*******************************************************************************
 *   Header Files                                                               *
 *******************************************************************************/
+#define LOG_GROUP LOG_GROUP_SUP_DRV
 #define __STDC_CONSTANT_MACROS
 #define __STDC_LIMIT_MACROS
@@ -46,5 +46,5 @@
 #include <iprt/process.h>
 #include <iprt/assert.h>
-#include <iprt/log.h>
+#include <VBox/log.h>
 #include <iprt/param.h>
 
Index: trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c	(revision 10662)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * VirtualBox Support Driver - Solaris Driver Code.
+ * VBoxDrv - The VirtualBox Support Driver - Solaris specifics.
  */
 
@@ -29,8 +29,8 @@
  */
 
-
 /*******************************************************************************
 *   Header Files                                                               *
 *******************************************************************************/
+#define LOG_GROUP LOG_GROUP_SUP_DRV
 #include <sys/types.h>
 #include <sys/param.h>
Index: trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 10661)
+++ trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 10662)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * VirtualBox Support Driver - Windows NT specific parts.
+ * VBoxDrv - The VirtualBox Support Driver - Windows NT specifics.
  */
 
@@ -29,9 +29,8 @@
  */
 
-
-
 /*******************************************************************************
 *   Header Files                                                               *
 *******************************************************************************/
+#define LOG_GROUP LOG_GROUP_SUP_DRV
 #include "../SUPDrvInternal.h"
 #include <excpt.h>
@@ -39,4 +38,5 @@
 #include <iprt/process.h>
 #include <iprt/initterm.h>
+#include <VBox/log.h>
 
 